/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2008 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.0 of the PHP license,       |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_0.txt.                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors: Ilia Alshanetsky <iliaa@php.net>                            |
  |          Graham Kelly <graham@php.net>                               |
  +----------------------------------------------------------------------+
*/
/* $Id: optimize_fcr.h,v 1.11 2008/08/07 11:37:19 graham Exp $ */

#ifndef OPTIMIZE_FCR_H
#define OPTIMIZE_FCR_H
/*
 * Function Call Reduction
 * 
 */


PHPAPI extern char *php_ini_scanned_files;

#define FN_DEFINED                 0
#define FN_EXTENSION_LOADED        1
#define FN_FUNCTION_EXISTS         2
#define FN_IS_CALLABLE             3
#define FN_CLASS_EXISTS            4
#define FN_INTERFACE_EXISTS        5
#define FN_STRLEN                  6
#define FN_GETLASTMOD              7
#define FN_GETMYUID                8
#define FN_GETMYGID                9
#define FN_GETMYINODE             10
#define FN_GET_CURRENT_USER       11
#define FN_PHPVERSION             12
#define FN_ZEND_VERSION           13
#define FN_PHP_SAPI_NAME          14
#define FN_PHP_LOGO_GUIDE         15
#define FN_ZEND_LOGO_GUIDE        16
#define FN_PHP_REAL_LOGO_GUIDE    17
#define FN_PHP_UNAME              19
#define FN_PHP_INI_SCANNED_FILES  20
#define FN_MD5                    21
#define FN_SHA1                   22
#define FN_CRC32                  23
#define FN_PI                     24
#define FN_GETRANDMAX             25
#define FN_MT_GETRANDMAX          26
#define FN_GET_MAGIC_QUOTES_GPC   27
#define FN_ORD                    28
#define FN_CHR                    29
#define FN_STRTOUPPER             30
#define FN_STRTOLOWER             31
#define FN_STRCMP                 32
#define FN_ADDSLASHES             33
#define FN_HTMLSPECIALCHARS       34
#define FN_HTMLENTITIES           35
#define FN_DIRNAME                36
#define FN_BASENAME               37
#define FN_REALPATH               38
#define FN_READLINK               39
#define FN_FILE_EXISTS            40
#define FN_IS_LINK                41
#define FN_IS_DIR                 42
#define FN_IS_FILE                43
#define FN_IS_EXECUTABLE          44
#define FN_IS_READABLE            45
#define FN_IS_WRITEABLE           46
#define FN_FILEATIME              47
#define FN_FILECTIME              48
#define FN_FILEGROUP              49
#define FN_FILEINODE              50
#define FN_FILEMTIME              51
#define FN_FILEOWNER              52
#define FN_FILEPERMS              53
#define FN_FILESIZE               54
#define FN_FILETYPE               55
#define FN_STRNCMP                56
#define FN_STRCASECMP             57
#define FN_STRNCASECMP            58
#define FN_VERSION_COMPARE        59
#define FN_DECHEX                 60
#define FN_HEXDEC                 61
#define FN_DECBIN                 62
#define FN_DECOCT                 63
#define FN_OCTDEC                 64
#define FN_STR_REPEAT             65
#define FN_INTVAL                 66

#define FN_SUBSTR                 67

#define FN_ACOS                   68
#define FN_ACOSH                  69
#define FN_ASIN                   70
#define FN_ASINH                  71
#define FN_ATAN                   72
#define FN_ATANH                  73
#define FN_COS                    74
#define FN_COSH                   75
#define FN_SIN                    76
#define FN_SINH                   77
#define FN_TAN                    78
#define FN_TANH                   79
#define FN_EXP                    80
#define FN_LOG10                  81
#define FN_SQRT                   82
#define FN_ATAN2                  83
#define FN_CEIL                   84
#define FN_FLOOR                  85
#define FN_FMOD                   86

#define FN_INI_GET                87

#define FN_IP2LONG                88
#define FN_LONG2IP                89
#define FN_TRIM                   90
#define FN_RTRIM                  91
#define FN_LTRIM                  92
#define FN_CHOP                   93

#define FN_PRINTF                 94

#define FN_FOPEN                  95
#define FN_READFILE               96
#define FN_FILE                   97
#define FN_FILE_GET_CONTENTS      98
#define FN_FILE_PUT_CONTENTS      99

#define FN_RAD2DEG               100
#define FN_DEG2RAD               101
#define FN_ABS                   102
#define FN_GET_CFG_VAR           103

#define FN_GET_CLASS_METHODS     1000
#define FN_GET_CLASS_VARS        1000
#define FN_GET_CLASS             1000
#define FN_GET_PARENT_CLASS      1000
#define FN_IS_A                  1000
#define FN_IS_SUBCLASS_OF        1000
#define FN_METHOD_EXISTS         1000
#define FN_PROPERTY_EXISTS       1000

#define FN_STRVAL                1000
#define FN_DOUBLEVAL             1000
#define FN_EMPTY                 1000
#define FN_FLOATVAL              1000
#define FN_GETTYPE               1000
#define FN_IS_ARRAY              1000
#define FN_IS_BINARAY            1000
#define FN_IS_BOOL               1000
#define FN_IS_BUFFER             1000
#define FN_IS_DOUBLE             1000
#define FN_IS_FLOAT              1000
#define FN_IS_INT                1000
#define FN_IS_INTEGER            1000
#define FN_IS_LONG               1000
#define FN_IS_NULL               1000
#define FN_IS_NUMERIC            1000
#define FN_IS_OBJECT             1000
#define FN_IS_REAL               1000
#define FN_IS_RESOURCE           1000
#define FN_IS_SCALAR             1000
#define FN_IS_STRING             1000
#define FN_IS_UNICODE            1000
#define FN_IS_ISSET              1000
#define FN_IS_SERIALIZE          1000
#define FN_IS_VAR_DUMP           1000

#define FN_VPRINTF               1000
#define FN_SPRINTF               1000
#define FN_VSPRINTF              1000
#define FN_SSCANF                1000

#define FN_ARRAY_COUNT_VALUES    1000
#define FN_ARRAY_FILL_KEYS       1000
#define FN_ARRAY_FILL            1000
#define FN_ARRAY_FLIP            1000
#define FN_ARRAY_KEY_EXISTS      1000
#define FN_ARRAY_KEYS            1000
#define FN_ARRAY_MERGE           1000
#define FN_ARRAY_PAD             1000
#define FN_ARRAY_PRODUCT         1000
#define FN_ARRAY_PUSH            1000
#define FN_ARRAY_REVERSE         1000
#define FN_ARRAY_SUM             1000
#define FN_ARRAY_UNIQUE          1000
#define FN_ARRAY_VALUES          1000
#define FN_ARSORT                1000
#define FN_ASORT                 1000
#define FN_COMPACT               1000
#define FN_COUNT                 1000
#define FN_IN_ARRAY              1000
#define FN_LIST                  1000
#define FN_RSORT                 1000
#define FN_SIZEOF                1000
#define FN_SORT                  1000

#define FN_EXPML                 1000
#define FN_MAX                   1000
#define FN_MIN                   1000
#define FN_POW                   1000
#define FN_ROUND                 1000


#define FN_BASIC 104

typedef struct _fcr_func_entry {
	const char* name;
	zend_uchar fid;
	optimizer_dt return_types; /* Bitfield with return types  */
	zend_uchar flags;
} fcr_func_entry;

extern const fcr_func_entry fn[FN_BASIC];

#define FN_EXTERNAL_MODIFIER 1 /* Set if the function is an external modifier function */
#define FN_OPTIMIZE_SILENCE  2 /* Set if silence blocks can be optimized out for this function call (i.e @abs($a)) */
#define FN_OPTIMIZABLE       4 /* Indicates that a function is optimizable */
#define FN_OPTIMIZABLE_STATIC 8 /* indicates that a function is optimizable when there are all static parameters */
#define FN_OPTIMIZABLE_STATIC_ONLY_MASK 16 /* indicates that the function is ONLY optimizable when there is all static params */
#define FN_OPTIMIZABLE_STATIC_ONLY (FN_OPTIMIZABLE | FN_OPTIMIZABLE_STATIC | FN_OPTIMIZABLE_STATIC_ONLY_MASK) /* Indicates that the function is only optimizable when it has all static parameters being passed to it */

#define FCR_FUNC(fname, fname_upper, ret_type, flags) {#fname, FN_##fname_upper, ret_type, flags},

void optimize_fcall(zend_op** a, zend_op** b, CB* cb, zend_op_array* op_array, zend_op** Ts, HashTable* fh OPTIMIZER_STATS_PARAM TSRMLS_DC);
int can_optimize_fcall(zend_op* op);
zend_bool fcall_return_value_used(zend_op* op);

void fcr_table_ctor(HashTable* fh);
#define fcr_table_dtor(fh) zend_hash_destroy(fh)

#endif


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
